package be.yellowduck.services;

import java.util.*;
import javax.activation.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.mail.util.*;
import org.springframework.mail.javamail.*;
import be.yellowduck.model.*;

public class EmailService {
    
    private JavaMailSenderImpl mailSender = null;
    
    public void setMailSender(JavaMailSenderImpl mailSender) {
        this.mailSender = mailSender;
    }
    
    public void sendEmail(Email email) throws MessagingException {
        
        MimeMessage mimeMessage = mailSender.createMimeMessage();
        boolean hasAttachments = (email.getAttachments() != null && email.getAttachments().size() > 0 );
        MimeMessageHelper helper = new MimeMessageHelper(mimeMessage, hasAttachments);
        helper.setTo(email.getTo());
        helper.setFrom(email.getFrom());
        helper.setSubject(email.getSubject());
        helper.setText(email.getText(), true);
   
        List<Attachment> attachments = email.getAttachments();
        if(attachments != null && attachments.size() > 0) {
            for (Attachment attachment : attachments) {
                String filename = attachment.getFilename() ;
                DataSource dataSource = new ByteArrayDataSource(attachment.getData(), attachment.getMimeType());
                if (attachment.isInline()) {
                    helper.addInline(filename, dataSource);
                } else {
                    helper.addAttachment(filename, dataSource);
                }
            }
        }
        
        mailSender.send(mimeMessage);
        
    }

}
